"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compile = void 0;
const ts = __importStar(require("typescript"));
const runDiagnostics_1 = require("../diagnostics/runDiagnostics");
const createProgram_1 = require("../program/createProgram");
const createPrinter_1 = require("../printer/createPrinter");
const compile = (fileName, code) => {
    const sourceFile = ts.createSourceFile(fileName, code, ts.ScriptTarget.ESNext);
    const program = (0, createProgram_1.createProgram)(fileName, sourceFile);
    const diagnosticResult = (0, runDiagnostics_1.runDiagnostics)(program);
    return diagnosticResult ? (0, createPrinter_1.createPrinter)(sourceFile) : '';
};
exports.compile = compile;
