#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseMarkdown = void 0;
const fs = __importStar(require("fs"));
const generatorExtensions_enum_1 = require("../enums/generatorExtensions.enum");
const paths_enum_1 = require("../enums/paths.enum");
const fileFinder_1 = require("../fileFinder/fileFinder");
const generatePattern_1 = require("../compiler/generatePattern");
const parseMarkdown = () => {
    (0, fileFinder_1.findFiles)(paths_enum_1.paths.root, generatorExtensions_enum_1.generatorExtensions.md).forEach(file => {
        const generator = {
            filePath: '',
            fileNamePattern: '',
            codePatterns: [],
        };
        const markdownFile = fs.readFileSync(file.path, 'utf-8');
        const lines = markdownFile.split(/\r?\n/);
        const filePath = lines
            .slice(lines.indexOf("filePath" /* Tokens.FilePath */) + 1, lines.indexOf("fileNamePattern" /* Tokens.FileNamePattern */))
            .filter(Boolean);
        const fileNamePattern = lines
            .slice(lines.indexOf("fileNamePattern" /* Tokens.FileNamePattern */) + 1, lines.indexOf("codePatterns" /* Tokens.CodePatterns */))
            .filter(Boolean);
        const codePatternsBlock = lines.slice(lines.indexOf("codePatterns" /* Tokens.CodePatterns */) + 1, lines.length);
        const codePatterns = [];
        while (codePatternsBlock.length > 0) {
            if (codePatternsBlock.indexOf("```" /* Tokens.Markdown */) === -1) {
                break;
            }
            const codePattern = codePatternsBlock
                .splice(codePatternsBlock.indexOf("```TypeScript" /* Tokens.MarkdownTS */), codePatternsBlock.indexOf("```" /* Tokens.Markdown */) + 1)
                .filter(e => e !== "```TypeScript" /* Tokens.MarkdownTS */ && e !== "```" /* Tokens.Markdown */);
            const codePatternObjects = [];
            for (let i = 0; i < codePattern.length; i++) {
                codePatternObjects.push({
                    pattern: codePattern[i],
                    static: !codePattern[i].includes("// pattern" /* Tokens.Pattern */),
                });
            }
            codePatterns.push(codePatternObjects);
        }
        generator.filePath = filePath[0].replaceAll("`" /* Tokens.Snippet */, '');
        generator.fileNamePattern = fileNamePattern[0].replaceAll("`" /* Tokens.Snippet */, '');
        generator.codePatterns = codePatterns;
        (0, generatePattern_1.generatePattern)(generator);
    });
};
exports.parseMarkdown = parseMarkdown;
